

def variace_s_opakovanim(n, k):
    """Vytiskne seznam vsech variaci k-te tridy z {1...n}"""
    def _variace(i):
        """nageneruj [i:k]"""
        for j in range(1, n+1):
            v[i] = j
            if i < k-1:
                _variace(i+1) # dogeneruj [i+1:k]
            else:
                print(v)


    v = [0] * k
    _variace(0)

def variace_s_opakovanim_list(n, k):
    """Vraci seznam vsech variaci k-te tridy z {1...n}"""
    def _variace(i):
        """nageneruj [i:k]"""
        for j in range(1, n+1):
            v[i] = j
            if i < k-1:
                _variace(i+1) # dogeneruj [i+1:k]
            else:
                vysledek.append(list(v)) # Q: proc list(...)?
                

    v = [0] * k
    vysledek = []
    _variace(0)
    return vysledek

def variace_s_opakovanim_jinak(n,k):
    """Vraci seznam vsech variaci s opakovanim k-te tridy z {1...n}"""
    if k >= 1:
        vysledek = []
        for i in range(1,n+1):
            for v in variace_s_opakovanim_jinak(n,k-1):
                vysledek.append([i] + v)
        return vysledek
    else:
        return [[]] # seznam vysledku == 1 prazdna variace


def variace_bez_opakovani(n, k):
    def _variace(i):
        """nageneruj [i:k]"""
        for j in range(1, n+1):
            if j not in v[0:i]: # j neni pouzite
                v[i] = j
                if i < k-1:
                    _variace(i+1) # dogeneruj [i+1:k]
                else:
                    print(v)

    v = [0] * k
    _variace(0)

def variace_bez_opakovani_v2(n, k):
    def _variace(i):
        """nageneruj [i:k]"""
        for j in range(1, n+1):
            if not je_pouzite[j]:
                je_pouzite[j] = True
                v[i] = j
                if i < k-1:
                    _variace(i+1) # dogeneruj [i+1:k]
                else:
                    print(v)
                je_pouzite[j] = False

    v = [0] * k
    je_pouzite = [False]*(n+1)
    _variace(0)

def permutace(n):
    variace_bez_opakovani_v2(n,n)


# --------

# print(variace_s_opakovanim(3,3))
# print(variace_s_opakovanim_jinak(3,2))
print(variace_bez_opakovani(4,3))



# list(range(1,n+1))
# l1 = [1,2,3,4]
# print([2*i for i in l1])


